<div class="container" fxLayout="column" fxLayoutAlign="start center">
  <div
    class="header"
    fxLayout="row"
    fxLayoutAlign="center center"
    fxLayoutGap="10px"
  >
    <div
      matRipple
      class="endpoint-container"
      *ngFor="let endpoint of this.endpoints"
      (click)="this.setSelectedEndpoint(endpoint)"
    >
      <p>{{ endpoint }}</p>
    </div>
  </div>

  <p style="margin-bottom: 20px">{{ this.selectedEndpoint }}</p>

  <!-- custom table -->
  <div
    *ngIf="this.selectedEndpoint && this.dataForTable.length > 0"
    class="table"
    fxLayout="row"
    fxLayoutAlign="center start"
  >
    <div
      class="table-column"
      *ngFor="
        let attrName of this.getDocKeys(this.docRecipes[this.selectedEndpoint])
      "
    >
      <div class="table-column-title">
        <p>{{ attrName }}</p>
      </div>

      <div class="table-cell" *ngFor="let tableData of this.dataForTable">
        <!-- disabled: false -->

        <!-- cellHTMLElement:INPUT-TEXT -->
        <input
          #input
          type="text"
          *ngIf="
            this.docRecipes[this.selectedEndpoint][attrName][
              'cellHTMLElement'
            ] === 'INPUT-TEXT'
          "
          [value]="
            this.docRecipes[this.selectedEndpoint][attrName]['getValue'](
              tableData['doc']
            )
          "
          (change)="
            this.docRecipes[this.selectedEndpoint][attrName]['setValue'](
              input.value,
              tableData,
              attrName,
              this.entityRegister,
              this.CRUDService
            )
          "
          [disabled]="attrName === '_id' ? true : this.disabled"
        />

        <!-- cellHTMLElement:INPUT-NUMBER -->
        <input
          #input
          type="number"
          *ngIf="
            this.docRecipes[this.selectedEndpoint][attrName][
              'cellHTMLElement'
            ] === 'INPUT-NUMBER'
          "
          [value]="
            this.docRecipes[this.selectedEndpoint][attrName]['getValue'](
              tableData['doc']
            )
          "
          (change)="
            this.docRecipes[this.selectedEndpoint][attrName]['setValue'](
              input.value,
              tableData,
              attrName,
              this.entityRegister,
              this.CRUDService
            )
          "
          [disabled]="this.disabled"
        />

        <!-- cellHTMLElement:INPUT-DATE -->
        <input
          #input
          type="date"
          *ngIf="
            this.docRecipes[this.selectedEndpoint][attrName][
              'cellHTMLElement'
            ] === 'INPUT-DATE'
          "
          [value]="
            this.docRecipes[this.selectedEndpoint][attrName]['getValue'](
              tableData['doc']
            )
          "
          (change)="
            this.docRecipes[this.selectedEndpoint][attrName]['setValue'](
              input.value,
              tableData,
              attrName,
              this.entityRegister,
              this.CRUDService
            )
          "
          [disabled]="this.disabled"
        />

        <!-- cellHTMLElement:INPUT-TIME -->
        <!-- value treba da bude "13:30" -->
        <input
          #input
          type="time"
          *ngIf="
            this.docRecipes[this.selectedEndpoint][attrName][
              'cellHTMLElement'
            ] === 'INPUT-TIME'
          "
          [value]="
            this.docRecipes[this.selectedEndpoint][attrName]['getValue'](
              tableData['doc']
            )
          "
          (change)="
            this.docRecipes[this.selectedEndpoint][attrName]['setValue'](
              input.value,
              tableData,
              attrName,
              this.entityRegister,
              this.CRUDService
            )
          "
          [disabled]="this.disabled"
        />

        <!-- cellHTMLElement:SELECT -->
        <select
          #select
          *ngIf="
            this.docRecipes[this.selectedEndpoint][attrName][
              'cellHTMLElement'
            ] === 'SELECT'
          "
          (change)="
            this.docRecipes[this.selectedEndpoint][attrName]['setValue'](
              select.value,
              tableData,
              attrName,
              this.entityRegister,
              this.CRUDService
            )
          "
          [disabled]="this.disabled"
        >
          <option
            [value]="undefined"
            [selected]="
              undefined ===
              this.docRecipes[this.selectedEndpoint][attrName]['getValue'](
                tableData['doc']
              )
                ? true
                : false
            "
          >
            undefined
          </option>
          <option
            *ngFor="
              let value of this.docRecipes[this.selectedEndpoint][attrName][
                'getOptions'
              ](this.data)
            "
            [value]="value"
            [selected]="
              value ===
              this.docRecipes[this.selectedEndpoint][attrName]['getValue'](
                tableData['doc']
              )
                ? true
                : false
            "
          >
            {{ value }}
          </option>
        </select>

        <!-- disabled: true -->

        <!-- cellHTMLElement:LIST -->
        <div
          *ngIf="
            this.docRecipes[this.selectedEndpoint][attrName][
              'cellHTMLElement'
            ] === 'LIST'
          "
          style="overflow-y: scroll; height: 100%"
        >
          <p
            *ngFor="
              let data of this.docRecipes[this.selectedEndpoint][attrName][
                'getValue'
              ](tableData['doc'])
            "
          >
            {{ data }}
          </p>
        </div>
      </div>
    </div>

    <!-- ukupna cena proizvoda sa popustom - za endpoint kupci -->
    <div *ngIf="this.selectedEndpoint === 'kupci'" class="table-column">
      <div class="table-column-title">
        <p>ukupna cena sa popustom</p>
      </div>

      <div
        class="table-cell"
        *ngFor="let tableData of this.dataForTable"
        fxLayout="column"
        fxLayoutAlign="center center"
      >
        <p>{{ this.getFullPriceWithDiscount(tableData) }} rsd</p>
      </div>
    </div>

    <!-- delete column -->
    <div class="table-column">
      <div class="table-column-title">
        <p>delete</p>
      </div>

      <div
        matRipple
        class="table-cell"
        *ngFor="let tableData of this.dataForTable"
        style="cursor: pointer"
        fxLayout="column"
        fxLayoutAlign="center center"
        (click)="this.deleteEntity(tableData.entity)"
      >
        <img width="30" src="./assets/icon/trash.png" alt="delete" />
      </div>
    </div>
  </div>

  <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
    <div
      matRipple
      class="enable-update"
      *ngIf="this.selectedEndpoint && this.dataForTable.length > 0"
      (click)="this.disabled = !this.disabled"
    >
      <p>{{ this.disabled ? "enable" : "disable" }} update</p>
    </div>

    <div
      matRipple
      class="add-new"
      *ngIf="this.selectedEndpoint && this.dataForTable.length > 0"
      (click)="this.addNewEntity()"
    >
      <p>add new</p>
    </div>
  </div>

  <!--  -->
</div>
